function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var Toastify = _interopDefault(require('toastify-js'));
require('toastify-js/src/toastify.css');
var Popover = _interopDefault(require('react-tiny-popover'));
var styled = _interopDefault(require('styled-components'));

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _templateObject7() {
  var data = _taggedTemplateLiteralLoose(["\n  font-size: 1.2em;\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteralLoose(["\n  border-radius: 50%;\n  background-color: #b9b9b9;\n  width: 12px;\n  padding: 8px;\n  margin-right: 8px;\n  display: flex;\n  justify-content: center;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteralLoose(["\n  color: #000;\n  z-index: 1000;\n  margin-bottom: 5px;\n  display: flex;\n  align-items: center;\n  justify-content: flex-start;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteralLoose(["\n  background-color: #fff;\n  border-radius: 5px;\n  border: 1px solid #eaeaea;\n  box-shadow: 0 0 5px 1px rgba(0,0,0,0.1);\n  padding: 10px;\n  font-size: 14px;\n  display: flex;\n  flex-direction: column;\n  z-index: 999;\n  opacity: 0.7;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n  position: relative;\n  display: flex;\n  align-items: center;\n  justify-items: center;\n  border-radius: 5px;\n  padding: 5px;\n  color: #fff;\n  \n  &:hover {\n    cursor: pointer;\n  }\n\n  &.log {\n    background-color: #b9b9b9;\n    border: 2px solid #9c9c9c;\n  }\n\n  &.error {\n    background-color: #ff4242;\n    border: 2px solid #8c3333;\n  }\n  &.clear {\n    border-radius: 50%;\n    background-color: #656565;\n    border: 2px solid #484848;\n    width: 30px;\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  margin-left: 4px;\n  width: 28px;\n  height: 32px;\n  color: #fff;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  position: fixed;\n  background-color: #fff;\n  left: 20px;\n  bottom: 20px;\n  display: flex;\n  justify-content: space-around;\n  width: 280px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Wrapper = styled.div(_templateObject());
var Badge = styled.div(_templateObject2());
var Console = styled.div(_templateObject3());
var PopoverBody = styled.div(_templateObject4());
var PopoverItem = styled.div(_templateObject5());
var PopoverCount = styled.div(_templateObject6());
var PopoverInfo = styled.div(_templateObject7());

var Toaster = function Toaster(_ref) {
  var _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'bottom' : _ref$position,
      _ref$duration = _ref.duration,
      duration = _ref$duration === void 0 ? '4000' : _ref$duration,
      destination = _ref.destination,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className;

  var _useState = React.useState(0),
      logCount = _useState[0],
      setLogCount = _useState[1];

  var _useState2 = React.useState([]),
      logInfo = _useState2[0],
      setLogInfo = _useState2[1];

  var _useState3 = React.useState(false),
      openLog = _useState3[0],
      setOpenLog = _useState3[1];

  var _useState4 = React.useState(0),
      errorCount = _useState4[0],
      setErrorCount = _useState4[1];

  var _useState5 = React.useState([]),
      errorInfo = _useState5[0],
      setErrorInfo = _useState5[1];

  var _useState6 = React.useState(false),
      openError = _useState6[0],
      setOpenError = _useState6[1];

  React.useEffect(function () {
    if (window.console && console) {

      console.log = function (args) {
        Toastify({
          text: args,
          gravity: position,
          stopOnFocus: true,
          duration: duration,
          className: className,
          newWindow: true,
          destination: destination || "https://google.com/search?q=" + args,
          backgroundColor: '#b9b9b9'
        }).showToast();
        setLogCount(function (prevCount) {
          return prevCount + 1;
        });
        var newLogInfo = logInfo;
        newLogInfo.push({
          body: args,
          count: 1,
          date: new Date(Date.now()).toISOString()
        });
        setLogInfo(newLogInfo);
      };

      console.error = function (args) {
        Toastify({
          text: args,
          gravity: position,
          stopOnFocus: true,
          duration: duration,
          className: className,
          newWindow: true,
          destination: destination || "https://google.com/search?q=" + args,
          backgroundColor: '#ff4242'
        }).showToast();
        setErrorCount(function (prevCount) {
          return prevCount + 1;
        });
        var newErrorInfo = errorInfo;

        if (errorInfo.find(function (error) {
          return error.body === args;
        })) {
          var i = errorInfo.findIndex(function (error) {
            return error.body === args;
          });
          newErrorInfo[i].count++;
          setErrorInfo(newErrorInfo);
        } else {
          newErrorInfo.push({
            body: args,
            count: 1,
            date: new Date(Date.now()).toISOString()
          });
          setErrorInfo(newErrorInfo);
        }
      };
    }
  }, []);

  var clearState = function clearState() {
    setErrorInfo([]);
    setErrorCount(0);
    setLogInfo([]);
    setLogCount(0);
  };

  return /*#__PURE__*/React__default.createElement(Wrapper, null, /*#__PURE__*/React__default.createElement(Popover, {
    isOpen: openLog,
    position: 'top',
    onClickOutside: function onClickOutside() {
      return setOpenLog(false);
    },
    content: /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(PopoverBody, null, logInfo.length > 0 ? logInfo.map(function (item, index) {
      return /*#__PURE__*/React__default.createElement(PopoverItem, {
        key: index
      }, /*#__PURE__*/React__default.createElement(PopoverCount, null, item.count), /*#__PURE__*/React__default.createElement(PopoverInfo, null, item.body));
    }) : /*#__PURE__*/React__default.createElement(PopoverItem, null, "No console.log() yet")))
  }, function (ref) {
    return /*#__PURE__*/React__default.createElement(Console, {
      ref: ref,
      className: "log",
      onClick: function onClick() {
        return setOpenLog(!openLog);
      }
    }, /*#__PURE__*/React__default.createElement("svg", {
      width: "24",
      height: "24",
      fill: "none",
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      "stroke-width": "2",
      stroke: "#fff",
      viewBox: "0 0 24 24"
    }, /*#__PURE__*/React__default.createElement("path", {
      d: "M7 8h10M7 12h4m1 8l-4-4H5a2 2 0 01-2-2V6a2 2 0 012-2h14a2 2 0 012 2v8a2 2 0 01-2 2h-3l-4 4z"
    })), /*#__PURE__*/React__default.createElement(Badge, {
      className: "log"
    }, logCount));
  }), /*#__PURE__*/React__default.createElement(Popover, {
    isOpen: openError,
    position: 'top',
    onClickOutside: function onClickOutside() {
      return setOpenError(false);
    },
    content: /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(PopoverBody, null, errorInfo.length > 0 ? errorInfo.map(function (item, index) {
      return /*#__PURE__*/React__default.createElement(PopoverItem, {
        key: index
      }, /*#__PURE__*/React__default.createElement(PopoverCount, null, item.count), /*#__PURE__*/React__default.createElement(PopoverInfo, null, item.body));
    }) : /*#__PURE__*/React__default.createElement(PopoverItem, null, "No console.error() yet")))
  }, function (ref) {
    return /*#__PURE__*/React__default.createElement(Console, {
      ref: ref,
      className: "error",
      onClick: function onClick() {
        return setOpenError(!openError);
      }
    }, /*#__PURE__*/React__default.createElement("svg", {
      width: "24",
      height: "24",
      fill: "none",
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      "stroke-width": "2",
      stroke: "#fff",
      viewBox: "0 0 24 24"
    }, /*#__PURE__*/React__default.createElement("path", {
      d: "M12 9v2m0 4h.01m-6.938 4h13.856c1.54 0 2.502-1.667 1.732-3L13.732 4c-.77-1.333-2.694-1.333-3.464 0L3.34 16c-.77 1.333.192 3 1.732 3z"
    })), /*#__PURE__*/React__default.createElement(Badge, {
      className: "error"
    }, errorCount));
  }), /*#__PURE__*/React__default.createElement(Console, {
    className: "clear",
    onClick: clearState
  }, /*#__PURE__*/React__default.createElement("svg", {
    style: {
      marginLeft: '3px'
    },
    width: "24",
    height: "24",
    fill: "none",
    "stroke-linecap": "round",
    "stroke-linejoin": "round",
    "stroke-width": "2",
    stroke: "currentColor",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("path", {
    d: "M19 7l-.867 12.142A2 2 0 0116.138 21H7.862a2 2 0 01-1.995-1.858L5 7m5 4v6m4-6v6m1-10V4a1 1 0 00-1-1h-4a1 1 0 00-1 1v3M4 7h16"
  }))));
};

module.exports = Toaster;
//# sourceMappingURL=index.js.map
